SystemOrganization addCategory: #'Volunti-GenerationServers-Model'!
SystemOrganization addCategory: #'Volunti-GenerationServers-View'!

VOServerComponent subclass: #VOGenerationServerView
	instanceVariableNames: 'idgsLog kgsLog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-View'!

!VOGenerationServerView class methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/5/2012 07:28'!
initialize
	super initialize.
	self register! !

!VOGenerationServerView class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:35'!
url
	^ 'generationserver'! !

!VOGenerationServerView methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 8/22/2012 08:49'!
children
	^ OrderedCollection new
		addAll: super children;
		add: kgsLog;
		add: idgsLog;
		yourself! !

!VOGenerationServerView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:34'!
idGenerationServer
	^ VOIDGenerationServer current! !

!VOGenerationServerView methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 10/29/2012 10:04'!
initialize
	super initialize.
	kgsLog := VOLogComponent new log: self keyGenerationServer log.
	idgsLog := VOLogComponent new log: self idGenerationServer log! !

!VOGenerationServerView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:32'!
keyGenerationServer
	^ VOKeyGenerationServer current! !

!VOGenerationServerView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/3/2012 16:34'!
renderAgentListOn: html
	self renderKeyGenerationServerOn: html.
	self renderIDGenerationServerOn: html! !

!VOGenerationServerView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 08:50'!
renderIDGenerationServerOn: html
	html heading
		level2;
		class: 'tit';
		with: 'ID Generation Server'.
	html
		form: [ 
			html text: 'Start or stop the server '.
			self idGenerationServer isRunning
				ifTrue: [ self renderAction: [ self idGenerationServer stop ] text: 'Stop' on: html ]
				ifFalse: [ self renderAction: [ self idGenerationServer start ] text: 'Start' on: html ] ].
	html anchor
		onClick: ((html jQuery: #idgs) toggle: 1);
		with: 'show/hide log'.
	html div
		id: #idgs;
		style: 'display:none;';
		with: [ html render: idgsLog ]! !

!VOGenerationServerView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 08:50'!
renderKeyGenerationServerOn: html
	html heading
		level2;
		class: 'tit';
		with: 'Key Generation Server'.
	html
		form: [ 
			html text: 'Start or stop the server '.
			self keyGenerationServer isRunning
				ifTrue: [ self renderAction: [ self keyGenerationServer stop ] text: 'Stop' on: html ]
				ifFalse: [ self renderAction: [ self keyGenerationServer start ] text: 'Start' on: html ] ].
	html
		paragraph: [ 
			html text: self keyGenerationServer numberOfKeyPairs greaseString , ' key pairs are available. '.
			html anchor
				callback: [ self keyGenerationServer generateKeyPairs ];
				with: 'Create ' , self keyGenerationServer defaultNumberOfKeyPairs greaseString , ' new ones'.
			html text: '.' ].
	html anchor
		onClick: ((html jQuery: #kgs) toggle: 1);
		with: 'show/hide log'.
	html div
		id: #kgs;
		style: 'display:none;';
		with: [ html render: kgsLog ]! !

!VOGenerationServerView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:35'!
title
	^ 'Generation Servers'! !

VOCertifiedAgent subclass: #VOIDGenerationServer
	instanceVariableNames: 'ids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-Model'!

VOIDGenerationServer class
	instanceVariableNames: 'ids'!

VOIDGenerationServer class
	instanceVariableNames: 'ids'!

!VOIDGenerationServer class methodsFor: 'generator' stamp: 'NicolasVanderAuwera 5/3/2012 16:19'!
generateID
	| id |
	[ 
	id := SecureRandom new nextFrom: 10000 to: 1000000.
	self ids includes: id ] whileTrue.
	self ids add: id.
	^ id! !

!VOIDGenerationServer class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/3/2012 16:17'!
ids
	ids isNil
		ifTrue: [ ids := SortedCollection new ].
	^ ids! !

!VOIDGenerationServer class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/22/2012 15:43'!
new
	^ super new start! !

!VOIDGenerationServer class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 5/5/2012 15:56'!
organisationUnit
	^ 'ID Generator'! !

!VOIDGenerationServer class methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/3/2012 16:19'!
port
	^ 3278! !

!VOIDGenerationServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/5/2012 16:13'!
handle: aSymbol
	super handle: aSymbol.
	aSymbol = #id
		ifFalse: [ ^ self ].
	self sendID! !

!VOIDGenerationServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/22/2012 08:02'!
sendID
	stream sendCommand: self class generateID.
	self addInLog: 'A new identifier has been send.'! !

VOCertifiedAgent subclass: #VOKeyGenerationServer
	instanceVariableNames: 'p q keyPairs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-GenerationServers-Model'!

!VOKeyGenerationServer commentStamp: 'NicolasVanderAuwera 3/10/2012 15:53' prior: 0!
I generate RSA key pair based on the same modulo.!

!VOKeyGenerationServer class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/22/2012 15:44'!
new
	^ super new start! !

!VOKeyGenerationServer class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 5/5/2012 15:56'!
organisationUnit
	^ 'Key Generator'! !

!VOKeyGenerationServer class methodsFor: 'network' stamp: 'NicolasVanderAuwera 2/14/2012 12:49'!
port
	^ 7777! !

!VOKeyGenerationServer methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/3/2012 16:07'!
checkKeyPairs
	self keyPairs isEmpty
		ifTrue: [ self generateKeyPairs ]! !

!VOKeyGenerationServer methodsFor: 'generator' stamp: 'NicolasVanderAuwera 2/18/2012 10:05'!
defaultNumberOfKeyPairs
	^ 50! !

!VOKeyGenerationServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/5/2012 14:19'!
firstKeyPair
	^ self keyPairs removeFirst! !

!VOKeyGenerationServer methodsFor: 'generator' stamp: 'NicolasVanderAuwera 11/1/2012 14:15'!
generateKeyPair
	| gen |
	gen := VORSAKeyPairGenerator new
		bits: CryptographicParameters rsaKeyLength;
		p: p;
		q: q;
		yourself.
	^ Array with: gen publicKey with: gen privateKey! !

!VOKeyGenerationServer methodsFor: 'generator' stamp: 'NicolasVanderAuwera 8/22/2012 08:11'!
generateKeyPairs
	self defaultNumberOfKeyPairs timesRepeat: [ self keyPairs add: self generateKeyPair ].
	self addInLog: self defaultNumberOfKeyPairs greaseString , ' key pairs have been generated.'! !

!VOKeyGenerationServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/10/2012 09:46'!
handle: aSymbol
	super handle: aSymbol.
	aSymbol = #keys
		ifTrue: [ self sendKeys ]! !

!VOKeyGenerationServer methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/1/2012 14:15'!
initialize
	| gen |
	super initialize.
	gen := VORSAKeyPairGenerator new bits: CryptographicParameters rsaKeyLength.
	p := gen p.
	q := gen q.
	self generateKeyPairs! !

!VOKeyGenerationServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/18/2012 10:06'!
keyPairs
	^ keyPairs ifNil: [ keyPairs := OrderedCollection new ]! !

!VOKeyGenerationServer methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 08:07'!
numberOfKeyPairs
	^ self keyPairs size! !

!VOKeyGenerationServer methodsFor: 'network' stamp: 'NicolasVanderAuwera 10/29/2012 15:00'!
sendKeys
	| kp |
	kp := self firstKeyPair.
	stream sendObject: kp first.
	stream sendObject: kp last.
	self addInLog: 'A key pair has been send. It remains ' , self numberOfKeyPairs greaseString , ' key pairs'! !

!VOKeyGenerationServer methodsFor: 'generator' stamp: 'NicolasVanderAuwera 5/3/2012 16:07'!
start
	self checkKeyPairs.
	super start! !
VOGenerationServerView initialize!
